//+------------------------------------------------------------------+
//|                                                         CCFp.mq4 |
//|                                              SemSemFX@rambler.ru |
//|              http://onix-trade.net/forum/index.php?showtopic=107 |
//|                                                                  |
//| Code cleanup and bug fixes by Robert Hill                        |
//+------------------------------------------------------------------+
#property copyright "SemSemFX@rambler.ru"
#property link      "http://onix-trade.net/forum/index.php?showtopic=107"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Black
#property indicator_color2 Black
#property indicator_color3 Black
#property indicator_color4 Black
#property indicator_color5 Black
#property indicator_color6 Black
#property indicator_color7 Black
#property indicator_color8 Black

#define TABSIZE  19                    // scale of currency's power !!!DON'T CHANGE THIS NUMBER!!!

string Indicator_Name = "CCFp4.1";
int Objs = 0;
extern string prefix = " Input proper prefix and suffix for pairs";
extern string prefix1 = "  ie: IBFX uses suffix m for MiniAccounts";
extern string symbol_prefix = "";
extern string symbol_suffix = "";
extern bool ShowObjects = true;

extern string cc = "CCFp Inputs";
extern int MA_Method = 3;
extern int Price = 6;
extern int Fast = 2;    // 3; Brandon
extern int Slow = 5;
extern color Color_USD = LimeGreen;
extern color Color_EUR = White;
extern color Color_GBP = SlateBlue;
extern color Color_CHF = Gray;
extern color Color_JPY = Orange;
extern color Color_AUD = Red;
extern color Color_CAD = Olive;
extern color Color_NZD = Magenta;
extern int Line_Thickness = 1;
extern int All_Bars = 1000;

double arrUSD[];
double arrEUR[];
double arrGBP[];
double arrCHF[];
double arrJPY[];
double arrAUD[];
double arrCAD[];
double arrNZD[];


string ObjectID = "CCFp1_";

int init() {
   
   string Sym = Symbol();
   Indicator_Name = StringConcatenate(Indicator_Name, ": ");
   if (StringFind(Sym,"USD") >= 0 ) Indicator_Name = StringConcatenate(Indicator_Name, " USD");
   if (StringFind(Sym,"EUR") >= 0 ) Indicator_Name = StringConcatenate(Indicator_Name, " EUR");
   if (StringFind(Sym,"GBP") >= 0 ) Indicator_Name = StringConcatenate(Indicator_Name, " GBP");
   if (StringFind(Sym,"CHF") >= 0 ) Indicator_Name = StringConcatenate(Indicator_Name, " CHF");
   if (StringFind(Sym,"AUD") >= 0 ) Indicator_Name = StringConcatenate(Indicator_Name, " AUD");
   if (StringFind(Sym,"CAD") >= 0 ) Indicator_Name = StringConcatenate(Indicator_Name, " CAD");
   if (StringFind(Sym,"JPY") >= 0 ) Indicator_Name = StringConcatenate(Indicator_Name, " JPY");
   if (StringFind(Sym,"NZD") >= 0 ) Indicator_Name = StringConcatenate(Indicator_Name, " NZD");
   IndicatorShortName(Indicator_Name);
   
   int width = 0;
   width = SetLineWidth ("USD");
   SetIndexStyle(0, DRAW_LINE, STYLE_SOLID, Line_Thickness, Color_USD);
   SetIndexBuffer(0, arrUSD);
   SetIndexLabel(0, "USD");
   width = SetLineWidth ("EUR");
   SetIndexStyle(1, DRAW_LINE, STYLE_SOLID, Line_Thickness, Color_EUR);
   SetIndexBuffer(1, arrEUR);
   SetIndexLabel(1, "EUR");
   width = SetLineWidth ("GBP");
   SetIndexStyle(2, DRAW_LINE, STYLE_SOLID, Line_Thickness, Color_GBP);
   SetIndexBuffer(2, arrGBP);
   SetIndexLabel(2, "GBP");
   width = SetLineWidth ("CHF");
   SetIndexStyle(3, DRAW_LINE, STYLE_SOLID, Line_Thickness, Color_CHF);
   SetIndexBuffer(3, arrCHF);
   SetIndexLabel(3, "CHF");
   width = SetLineWidth ("JPY");
   SetIndexStyle(4, DRAW_LINE, STYLE_SOLID, Line_Thickness, Color_JPY);
   SetIndexBuffer(4, arrJPY);
   SetIndexLabel(4, "JPY");
   width = SetLineWidth ("AUD");
   SetIndexStyle(5, DRAW_LINE, STYLE_SOLID, Line_Thickness, Color_AUD);
   SetIndexBuffer(5, arrAUD);
   SetIndexLabel(5, "AUD");
   width = SetLineWidth ("CAD");
   SetIndexStyle(6, DRAW_LINE, STYLE_SOLID, Line_Thickness, Color_CAD);
   SetIndexBuffer(6, arrCAD);
   SetIndexLabel(6, "CAD");
   width = SetLineWidth ("NZD");
   SetIndexStyle(7, DRAW_LINE, STYLE_SOLID, Line_Thickness, Color_NZD);
   SetIndexBuffer(7, arrNZD);
   SetIndexLabel(7, "NZD");
   
   Objs = 0;
   ObjectID = ObjectID + "_";
  
   //----
   return (0);
}

int SetLineWidth(string cur)
{
   if (StringFind(Symbol(), cur, 0) < 0) return(1);
   return(Line_Thickness);
}

int deinit() {
   if (ShowObjects)
   {
     delete_objects();
   }
   return (0);
}

void delete_objects()
{

   int i, tot;
   string object_name;

   tot = ObjectsTotal();
   
   for (i = tot; i>=0;i--)
   {
    object_name = ObjectName(i);
    if (StringFind(object_name, ObjectID) >= 0 ) ObjectDelete(object_name);
   }
}

void PlaceColorChart()
{
   string Sym = Symbol();
   int cur = 0;
   int st = 23;
   if (StringFind(Sym,"USD") >= 0 ) {
      sl("  ~", cur, Color_USD);
      cur += st;
   }
   if (StringFind(Sym,"EUR") >= 0 ) {
      sl("  ~", cur, Color_EUR);
      cur += st;
   }
   if (StringFind(Sym,"GBP") >= 0 ) {
      sl("  ~", cur, Color_GBP);
      cur += st;
   }
   if (StringFind(Sym,"CHF") >= 0 ) {
      sl("  ~", cur, Color_CHF);
      cur += st;
   }
   if (StringFind(Sym,"JPY") >= 0 ) {
      sl("  ~", cur, Color_JPY);
      cur += st;
   }
   if (StringFind(Sym,"AUD") >= 0 ) {
      sl("  ~", cur, Color_AUD);
      cur += st;
   }
   if (StringFind(Sym,"CAD") >= 0 ) {
      sl("  ~", cur, Color_CAD);
      cur += st;
   }
   if (StringFind(Sym,"NZD") >= 0 ) {
      sl("  ~", cur, Color_NZD);
      cur += st;
   }
}

int start() {
   int counted_bars = IndicatorCounted();
   if (counted_bars < 0) return (-1);
   int limit = All_Bars;
   
   if (Objs == 0) PlaceColorChart();
   CCFp(limit);
   return (0);
}

void CCFp(int limit)
{
   double EURUSD_Fast;
   double EURUSD_Slow;
   double GBPUSD_Fast;
   double GBPUSD_Slow;
   double AUDUSD_Fast;
   double AUDUSD_Slow;
   double NZDUSD_Fast;
   double NZDUSD_Slow;
   double USDCAD_Fast;
   double USDCAD_Slow;
   double USDCHF_Fast;
   double USDCHF_Slow;
   double USDJPY_Fast;
   double USDJPY_Slow;
   for (int i = 0; i < limit; i++)
   {
         EURUSD_Fast = ma("EURUSD", Fast, MA_Method, Price, i);
         EURUSD_Slow = ma("EURUSD", Slow, MA_Method, Price, i);
         if (!EURUSD_Fast || !EURUSD_Slow) break;

         GBPUSD_Fast = ma("GBPUSD", Fast, MA_Method, Price, i);
         GBPUSD_Slow = ma("GBPUSD", Slow, MA_Method, Price, i);
         if (!GBPUSD_Fast || !GBPUSD_Slow) break;

         AUDUSD_Fast = ma("AUDUSD", Fast, MA_Method, Price, i);
         AUDUSD_Slow = ma("AUDUSD", Slow, MA_Method, Price, i);
         if (!AUDUSD_Fast || !AUDUSD_Slow) break;

         NZDUSD_Fast = ma("NZDUSD", Fast, MA_Method, Price, i);
         NZDUSD_Slow = ma("NZDUSD", Slow, MA_Method, Price, i);
         if (!NZDUSD_Fast || !NZDUSD_Slow) break;

         USDCAD_Fast = ma("USDCAD", Fast, MA_Method, Price, i);
         USDCAD_Slow = ma("USDCAD", Slow, MA_Method, Price, i);
         if (!USDCAD_Fast || !USDCAD_Slow) break;

         USDCHF_Fast = ma("USDCHF", Fast, MA_Method, Price, i);
         USDCHF_Slow = ma("USDCHF", Slow, MA_Method, Price, i);
         if (!USDCHF_Fast || !USDCHF_Slow) break;

         USDJPY_Fast = ma("USDJPY", Fast, MA_Method, Price, i);
         USDJPY_Slow = ma("USDJPY", Slow, MA_Method, Price, i);
         if (!USDJPY_Fast || !USDJPY_Slow) break;


      if (StringFind(Symbol(), "USD", 0) != -1) {
         arrUSD[i] = 0;
         arrUSD[i] += (EURUSD_Slow / EURUSD_Fast - 1.0);
         arrUSD[i] += (GBPUSD_Slow / GBPUSD_Fast - 1.0);
         arrUSD[i] += (AUDUSD_Slow / AUDUSD_Fast - 1.0);
         arrUSD[i] += (NZDUSD_Slow / NZDUSD_Fast - 1.0);
         arrUSD[i] += (USDCHF_Fast / USDCHF_Slow - 1.0);
         arrUSD[i] += (USDCAD_Fast / USDCAD_Slow - 1.0);
         arrUSD[i] += (USDJPY_Fast / USDJPY_Slow - 1.0);
         arrUSD[i] *= 1000.0;
      }
      if (StringFind(Symbol(), "EUR", 0) != -1) {
         arrEUR[i] = 0;
         arrEUR[i] += (EURUSD_Fast / EURUSD_Slow - 1.0);
         arrEUR[i] += (EURUSD_Fast / GBPUSD_Fast / (EURUSD_Slow / GBPUSD_Slow) - 1.0);
         arrEUR[i] += (EURUSD_Fast / AUDUSD_Fast / (EURUSD_Slow / AUDUSD_Slow) - 1.0);
         arrEUR[i] += (EURUSD_Fast / NZDUSD_Fast / (EURUSD_Slow / NZDUSD_Slow) - 1.0);
         arrEUR[i] += (EURUSD_Fast * USDCHF_Fast / (EURUSD_Slow * USDCHF_Slow) - 1.0);
         arrEUR[i] += (EURUSD_Fast * USDCAD_Fast / (EURUSD_Slow * USDCAD_Slow) - 1.0);
         arrEUR[i] += (EURUSD_Fast * USDJPY_Fast / (EURUSD_Slow * USDJPY_Slow) - 1.0);
         arrEUR[i] *= 1000.0;
      }
      if (StringFind(Symbol(), "GBP", 0) != -1) {
         arrGBP[i] = 0;
         arrGBP[i] += (GBPUSD_Fast / GBPUSD_Slow - 1.0);
         arrGBP[i] += (EURUSD_Slow / GBPUSD_Slow / (EURUSD_Fast / GBPUSD_Fast) - 1.0);
         arrGBP[i] += (GBPUSD_Fast / AUDUSD_Fast / (GBPUSD_Slow / AUDUSD_Slow) - 1.0);
         arrGBP[i] += (GBPUSD_Fast / NZDUSD_Fast / (GBPUSD_Slow / NZDUSD_Slow) - 1.0);
         arrGBP[i] += (GBPUSD_Fast * USDCHF_Fast / (GBPUSD_Slow * USDCHF_Slow) - 1.0);
         arrGBP[i] += (GBPUSD_Fast * USDCAD_Fast / (GBPUSD_Slow * USDCAD_Slow) - 1.0);
         arrGBP[i] += (GBPUSD_Fast * USDJPY_Fast / (GBPUSD_Slow * USDJPY_Slow) - 1.0);
         arrGBP[i] *= 1000.0;
      }
      if (StringFind(Symbol(), "AUD", 0) != -1) {
         arrAUD[i] = 0;
         arrAUD[i] += (AUDUSD_Fast / AUDUSD_Slow - 1.0);
         arrAUD[i] += (EURUSD_Slow / AUDUSD_Slow / (EURUSD_Fast / AUDUSD_Fast) - 1.0);
         arrAUD[i] += (GBPUSD_Slow / AUDUSD_Slow / (GBPUSD_Fast / AUDUSD_Fast) - 1.0);
         arrAUD[i] += (AUDUSD_Fast / NZDUSD_Fast / (AUDUSD_Slow / NZDUSD_Slow) - 1.0);
         arrAUD[i] += (AUDUSD_Fast * USDCHF_Fast / (AUDUSD_Slow * USDCHF_Slow) - 1.0);
         arrAUD[i] += (AUDUSD_Fast * USDCAD_Fast / (AUDUSD_Slow * USDCAD_Slow) - 1.0);
         arrAUD[i] += (AUDUSD_Fast * USDJPY_Fast / (AUDUSD_Slow * USDJPY_Slow) - 1.0);
         arrAUD[i] *= 1000.0;
      }
      if (StringFind(Symbol(), "NZD", 0) != -1) {
         arrNZD[i] = 0;
         arrNZD[i] += (NZDUSD_Fast / NZDUSD_Slow - 1.0);
         arrNZD[i] += (EURUSD_Slow / NZDUSD_Slow / (EURUSD_Fast / NZDUSD_Fast) - 1.0);
         arrNZD[i] += (GBPUSD_Slow / NZDUSD_Slow / (GBPUSD_Fast / NZDUSD_Fast) - 1.0);
         arrNZD[i] += (AUDUSD_Slow / NZDUSD_Slow / (AUDUSD_Fast / NZDUSD_Fast) - 1.0);
         arrNZD[i] += (NZDUSD_Fast * USDCHF_Fast / (NZDUSD_Slow * USDCHF_Slow) - 1.0);
         arrNZD[i] += (NZDUSD_Fast * USDCAD_Fast / (NZDUSD_Slow * USDCAD_Slow) - 1.0);
         arrNZD[i] += (NZDUSD_Fast * USDJPY_Fast / (NZDUSD_Slow * USDJPY_Slow) - 1.0);
         arrNZD[i] *= 1000.0;
      }
      if (StringFind(Symbol(), "CAD", 0) != -1) {
         arrCAD[i] = 0;
         arrCAD[i] += (USDCAD_Slow / USDCAD_Fast - 1.0);
         arrCAD[i] += (EURUSD_Slow * USDCAD_Slow / (EURUSD_Fast * USDCAD_Fast) - 1.0);
         arrCAD[i] += (GBPUSD_Slow * USDCAD_Slow / (GBPUSD_Fast * USDCAD_Fast) - 1.0);
         arrCAD[i] += (AUDUSD_Slow * USDCAD_Slow / (AUDUSD_Fast * USDCAD_Fast) - 1.0);
         arrCAD[i] += (NZDUSD_Slow * USDCAD_Slow / (NZDUSD_Fast * USDCAD_Fast) - 1.0);
         arrCAD[i] += (USDCHF_Fast / USDCAD_Fast / (USDCHF_Slow / USDCAD_Slow) - 1.0);
         arrCAD[i] += (USDJPY_Fast / USDCAD_Fast / (USDJPY_Slow / USDCAD_Slow) - 1.0);
         arrCAD[i] *= 1000.0;
      }
      if (StringFind(Symbol(), "CHF", 0) != -1) {
         arrCHF[i] = 0;
         arrCHF[i] += (USDCHF_Slow / USDCHF_Fast - 1.0);
         arrCHF[i] += (EURUSD_Slow * USDCHF_Slow / (EURUSD_Fast * USDCHF_Fast) - 1.0);
         arrCHF[i] += (GBPUSD_Slow * USDCHF_Slow / (GBPUSD_Fast * USDCHF_Fast) - 1.0);
         arrCHF[i] += (AUDUSD_Slow * USDCHF_Slow / (AUDUSD_Fast * USDCHF_Fast) - 1.0);
         arrCHF[i] += (NZDUSD_Slow * USDCHF_Slow / (NZDUSD_Fast * USDCHF_Fast) - 1.0);
         arrCHF[i] += (USDCHF_Slow / USDCAD_Slow / (USDCHF_Fast / USDCAD_Fast) - 1.0);
         arrCHF[i] += (USDJPY_Fast / USDCHF_Fast / (USDJPY_Slow / USDCHF_Slow) - 1.0);
         arrCHF[i] *= 1000.0;
      }
      if (StringFind(Symbol(), "JPY", 0) != -1) {
         arrJPY[i] = 0;
         arrJPY[i] += (USDJPY_Slow / USDJPY_Fast - 1.0);
         arrJPY[i] += (EURUSD_Slow * USDJPY_Slow / (EURUSD_Fast * USDJPY_Fast) - 1.0);
         arrJPY[i] += (GBPUSD_Slow * USDJPY_Slow / (GBPUSD_Fast * USDJPY_Fast) - 1.0);
         arrJPY[i] += (AUDUSD_Slow * USDJPY_Slow / (AUDUSD_Slow * USDJPY_Fast) - 1.0);
         arrJPY[i] += (NZDUSD_Slow * USDJPY_Slow / (NZDUSD_Fast * USDJPY_Fast) - 1.0);
         arrJPY[i] += (USDJPY_Slow / USDCAD_Slow / (USDJPY_Fast / USDCAD_Slow) - 1.0);
         arrJPY[i] += (USDJPY_Slow / USDCHF_Slow / (USDJPY_Slow / USDCHF_Fast) - 1.0);
         arrJPY[i] *= 1000.0;
      }
    }
}

double ma(string sym, int per, int Mode, int Price, int i) {
   double res = 0;
   int k = 4;   // 1; Brandon
   int ma_shift = 0;
   int tf = 0;
   string mySym;
   
  mySym = symbol_prefix + sym + symbol_suffix;
   
   switch (Period()) {
   case PERIOD_M1:
      res += iMA(mySym, tf, per * k, ma_shift, Mode, Price, i);
      k += 5;
   case PERIOD_M5:
      res += iMA(mySym, tf, per * k, ma_shift, Mode, Price, i);
      k += 3;
   case PERIOD_M15:
      res += iMA(mySym, tf, per * k, ma_shift, Mode, Price, i);
      k += 2;
   case PERIOD_M30:
      res += iMA(mySym, tf, per * k, ma_shift, Mode, Price, i);
      k += 2;
   case PERIOD_H1:
      res += iMA(mySym, tf, per * k, ma_shift, Mode, Price, i);
      k += 4;
   case PERIOD_H4:
      res += iMA(mySym, tf, per * k, ma_shift, Mode, Price, i);
      k += 6;
   case PERIOD_D1:
      res += iMA(mySym, tf, per * k, ma_shift, Mode, Price, i);
      k += 5;  // 4; Brandon
   case PERIOD_W1:
      res += iMA(mySym, tf, per * k, ma_shift, Mode, Price, i);
      k += 4;
   case PERIOD_MN1:
      res += iMA(mySym, tf, per * k, ma_shift, Mode, Price, i);
   }
   // Comment("per*k  ",per*k);
   // Comment("k>MN ",k," res ",res);   
   return (res);
}

void sl(string sym, int y, color col) {
   int window = WindowFind(Indicator_Name);
   string ID;
   
   if (ShowObjects)
   {
     Objs++;
     ID = ObjectID + Objs;
     if (ObjectFind(ID) == -1 ){
       if (ObjectCreate(ID, OBJ_LABEL, window, 0, 0)) {
        ObjectSet(ID, OBJPROP_XDISTANCE, y + 34);
        ObjectSet(ID, OBJPROP_YDISTANCE, 0);
        ObjectSetText(ID, sym, 18, "Arial Black", col);
      }
     }
   }
}

